// Класс поисковой формы
function cSearch() {
    this._jSearchResultContainer = $('.SearchResult');
    this._jTemplateContainer = $("#resultPrototype");
    this._jSearchButton = $(".searchBtn");
    this._jNotFound = $(".SearchNotFound");
    this._Template = this._jTemplateContainer.html();
    this.Handler = "";

    // Замыкание
    var self = this;

    // Ответ, который получает сервер
    this._Response = {};

    // Get data from server
    this.Load = function (Handler, Data) {
        self._jNotFound.css("display", "none");
        self._jSearchResultContainer.css("display", "none");
        $.post(Handler, Data, function (response) {
            self._jSearchResultContainer.html("");
            if(response.length == 0)
            {
                self._jNotFound.css("display", "block");
                return;
            }
            self._jSearchResultContainer.css("display", "block");
            $.each(response, function (i) {
                self._jSearchResultContainer.append(
                    Mustache.render(self._Template, response[i])
                );
            });
        }, "json");
    };

    this.Init = function (Handler) {
        this._jTemplateContainer.html("");
        Mustache.parse(this._Template);
        this._EventsLinker();
        self.Handler = Handler;
    };

    this._EventsLinker = function () {
        // Привязываем кнопку поиска
        self._jSearchButton.click(self.Search());
        self.EventsLinker();
    };

    // Should be implemented by child classes
    this.Search = function () {
    };
    this.EventsLinker = function () {
    };
}

function SearchStudent(jName, jFacultySelect, jGradeSelect, jGroupSelect) {
    cSearch.call(this);

    this.Handler = "";
    var self = this;
    this.AdditionalRequestParams = {};
    this.Search = function () {
        var Request = $.extend(true, {
            'Name': jName.val(),
            'FacultyID': jFacultySelect.find('option:selected').val(),
            'GradeID': jGradeSelect.find('option:selected').val(),
            'GroupID': jGroupSelect.find('option:selected').val()
        }, self.AdditionalRequestParams);
        self.Load(self.Handler, Request);
    };

    this.EventsLinker = function () {
        var typeWatcher = function(e) {
            Watcher(700, function() {
                if (prevNameValue != jName.val())
                    self.Search();
                var prevNameValue = jName.val();
                $(this).blur();
            });
        };

        jName.keyup(typeWatcher).bind("paste", typeWatcher);
        jFacultySelect.change(function (){
            jGradeSelect.find('option[value=0]').attr("selected", "selected");
            jGroupSelect.html("").attr("disabled", "disabled").append('<option>-- Фильтр по группе --</option>');
            self.Search();
        });
        jGradeSelect.change(function () {
            self.Search();
            jGroupSelect.html("").attr("disabled", "disabled").append('<option>-- Фильтр по группе --</option>');
            $.post(URLdir + 'handler/students/getGroups',
                {
                    facultyID: jFacultySelect.find('option:selected').val(),
                    gradeNum: jGradeSelect.find('option:selected').val() // FIXME: хендлеру нужен gadeNum
                },
                function (response) {
                    jGroupSelect.removeAttr("disabled");
                    $.each(response, function (i) {
                        var option = Mustache.render("<option value='{{ ID }}'>{{ GroupNum }} группа ({{ SpecName }})</option>", response[i]);
                        jGroupSelect.append(option);
                    });
                },
                "json");
        });
        jGroupSelect.change(self.Search);
    }
}

function SearchTeacher(jName, jFacultySelect, jDepartmentSelect) {
    cSearch.call(this);

    this.Handler = "";
    var self = this;
    this.AdditionalRequestParams = {};
    this.Search = function () {
        var Request = $.extend(true, {
            'Name': jName.val(),
            'FacultyID': jFacultySelect.find('option:selected').val(),
            'DepartmentID': jDepartmentSelect.find('option:selected').val()
        }, self.AdditionalRequestParams);
        self.Load(self.Handler, Request);
    };

    this.EventsLinker = function () {
        jName.change(this.Search);
        jFacultySelect.change(function () {
            self.Search();
            jDepartmentSelect.html("").attr("disabled", "disabled").append('<option>-- Фильтр по кафедре --</option>');
            $.post(URLdir + 'handler/map/getDepartments',
                {
                    FacultyID: jFacultySelect.find('option:selected').val()
                },
                function (response) {
                    jDepartmentSelect.removeAttr("disabled");
                    $.each(response, function (i) {
                        var option = Mustache.render("<option value='{{ ID }}'>{{ Name }}</option>", response[i]);
                        console.log(option);
                        jDepartmentSelect.append(option);
                    });
                },
                "json");
        });
        jDepartmentSelect.change(this.Search);
    }
}
